#!perl -w

# this is the "second" script, it must start after the first, and 
# end before the first is done

# this script MUST be run in directory containing the test suite
# $nmod_calc is the number of models to actually compute here
# this is run on second slave machine and must end first
# slave will do this many, master will skip this many
#>>chng 06 aug 29, from 67 to 62, master found 8 undone model on a backup night
#>>chng 07 jan 03, from 55 to 51, added ism_grid, three sims were undone at end
#>>chng 07 jan 10, from 51 to 48, parallel in optimize_phymir?
$nmod_calc = 48;

$nMod = 0;
$nComputed = 0;
$nSkip = 0;

# the disk drive 
$c = "M";

# try using net use net use u: \\server-name\share-name\
system( "net use $c: \\\\cumulus\\cumulus_c\$ /persistent:no" );

$in_dir = "$c:/projects/cloudy/trunk/tsuite/auto/";
$out_dir = "$c:/projects/cloudy/trunk/tsuite/auto/";

# move to the output directory
if( !chdir( $out_dir ) )
{
	printf(ioLOG " invalid directory for output of test suite\n");
	printf(ioLOG " was ==%s==\n",$out_dir );
	exit(1);
}

$log_file = "autorun2.log";
open( ioLOG , ">$log_file" );
printf( ioLOG "have moved to output dir and opened log2 files\n");
printf( ioLOG "input dir is $in_dir, out is $out_dir\n");

$exe = "$c:/projects/cloudy/trunk/debug/trunk.exe";
printf(ioLOG "exe is $exe\n");

$TRUE = 1;
$FALSE = 0;

# if true then always recompute even when exe is older than results
$lgForceCompute = $TRUE;
# if false then only recompute when newer exe than results
$lgForceCompute = $FALSE;

# file containing any errors, also used for timestamp
$errors = "errors.txt";
# this file exists while long checking runs with purify are in pregress
$blockrun = "blockfile.txt";

# does $exe exist?
if( !open(EXEFILE, "$exe") ) 
{
	printf( ioLOG "executable did not exist so exiting without running.\n" );
	printf( STDERR "executable did not exist so exiting without running.\n" );
	exit(1);
}

# see if errors.txt exists, if it does, and younger than exe file, just quit
# $lgForceCompute set above, option to force recomputing model
if( !$lgForceCompute  )
{
	if( -e $errors )
	{
		# is age of errors file smaler than exe file?
		if( (-M $errors) < (-M EXEFILE ) )
		{
			printf( ioLOG "executable older than errors.txt so exit.\n" );
			# no need to run tests, just quit
			exit(2);
		}
		# this file created when purify test is running 
		if( -e $blockrun )
		{
			printf( ioLOG "blockrun file exists so exit.\n" );
			# no need to run tests, just quit
			exit(3);
		}
	}
}


printf( ioLOG "entering loop, exe is $exe \n" );

while( defined( $input = glob("$in_dir*.in") ) )
#while( defined( $input = glob("*.in") ) )
{
	if( $nMod >= $nSkip && $nMod < $nmod_calc )
	{
		# copy input file to fileout to exit it
		$output = $input;
		# change input dir name to output
		$output =~ s/$in_dir/$out_dir/gi;
		$output =~ s/$in_dir/$out_dir/gi;
		# change .in to .out
		$output =~ s/\.in/.out/gi;
		# $output = "$out_dir"."$output";
		# system "nice -n 5 $exe < $input  > $output ";
		printf( ioLOG "$input going to $output \n" );
		system "$exe < $input  > $output ";
		++$nComputed;
	}
	++$nMod;
}

printf( ioLOG "$nComputed sims were run\n");

exit(0);

